
App.ConnectionsView = Ember.View.extend({
    classNames: "connections",


    didInsertElement: function() {
        console.log("inserted");
        var view = this;
        var controller = this.get('controller');
        view.$("#list").sortable({
            axis: "y",
            //revert: 100,
            // handle: '.handle',

            stop: function(event, ui) {


            },
            
            helper: "clone",
            forceHelperSize: true,

            start: function (event, ui) {
                $(ui.item).click();
                // Temporarily move the dragged item to the end of the list so that it doesn't offset the items
                // below it (jQuery UI adds a 'placeholder' element which creates the desired offset during dragging)
                $(ui.item).appendTo(this).addClass("dragging");
            },
            update: function(event, ui) {
                var indexes = {};

                $(this).find('.connection').each(function(index) {
                  indexes[$(this).data('id')] = index;
                });

                $(this).sortable('cancel');

                controller.updateSortOrder(indexes);
            }
        })
    },

})

App.IndexController = Ember.ArrayController.extend({

    needs: 'application',

    sortProperties: ['position'],

    tipMessage: null,

    cliMessage: "Up to date",

    paused: false,

    online: true,

    newConnection: null,

    activeConnection: null,

    showMoreOptions: false,

    updateContent: function() {

    },

    updateSortOrder: function(indexes) {
        this.beginPropertyChanges();
        this.forEach(function(item) {
          var index = indexes[item.get('id')];
          item.set('position', index);
          item.save();
        }, this);
        this.endPropertyChanges();
    },

    selectedConnection: function(key, value) {

        if (arguments.length > 1) {

            this.filter(function(connection) {
                if (connection.get("selected") == true) {
                    connection.set('selected', false);
                }
            });

            this.set("activeConnection", value);
            if (value) {
                value.set("selected", true);
            }

        }


        if (this.get("newConnection") != null) {
            return this.get("newConnection");
        } else {
            return this.get("activeConnection");
        }
    }.property("activeConnection", "newConnection"),
    selectFirstObject: function() {
        m = this.get("content");
        if(m.objectAt(0) == undefined) {
            this.transitionToRoute("new");
        } else {
            this.set('selectedConnection', m.objectAt(0));
        }
    },

    selectNextObject: function() {
        m = this.get("content");
        if(m.objectAt(0) == undefined) {
            this.transitionToRoute("new");
        } else {
            s = this.get('selectedConnection');
            position = s.get("position") + 1;
            if(this.selectObjectAtPosition(position) == null) {
                this.selectObjectAtPosition(0);
            }
 
        }
    },

    selectPreviousObject: function() {
        m = this.get("content");
        if(m.objectAt(0) == undefined) {
            this.transitionToRoute("new");
        } else {
            position = s.get("position") - 1;
            if(this.selectObjectAtPosition(position) == null) {
                this.selectObjectAtPosition(m.get("length") - 1);
            }
        }
    },

    selectObjectAtPosition: function(position) {
        m = this.get("content");

        for(var i = 0; i < m.get("length"); i++) {
            o = m.objectAt(i);
            if(o && o.get("position") == position) {
                this.set('selectedConnection', o);
                return o;
            }
        }
        return null;
    },

    connectSelectedConnection: function() {
        this.send("connect");
        // theConnection = this.get("selectedConnection");
        // if(theConnection != undefined) {
        //     theConnection.connect();
        // }
    },

    actions: {
        updateSelectedConnection: function(theConnection) {
            this.set("selectedConnection", theConnection)
            if (theConnection._dirtyAttributes) {
                expandrive.log(JSON.stringify(theConnection.cleanJSON(), null, 2));
            }

        },
        newDrive: function() {
            this.transitionToRoute("new");
        },
        drives: function() {
            nc = this.get("newConnection");
            //            if(nc && nc.get('isNew')) {
            //               nc.destroyRecord();
            //         }
            this.set("newConnection", null);
            this.transitionToRoute("index");
        },
        settings: function() {
            this.transitionToRoute("settings");
        },
        moreOptions: function() {
            this.set("showMoreOptions", true);
        },
        fewerOptions: function() {
            this.set("showMoreOptions", false);
        },
        connect: function() {
            
            self = this;
            theConnection = this.get("selectedConnection");

            if(theConnection.get("isConnected")) {
                theConnection.reveal();
                return;
            }
            if(theConnection.get("isConnecting")) {
                return;
            }
            theConnection.setConnecting();

            this.set("newConnection", null);
            self.set("selectedConnection", theConnection);
            s = theConnection.save();
            
            s.then(function(tc) {
                tc.connect();
                self.transitionToRoute("index");
            });
            
        },
        validate: function() {
            self = this;
            theConnection = this.get("selectedConnection");
            theConnection.validateCredentials();
        },

        delete: function() {
            self = this;
            theConnection = this.get("selectedConnection");
            theConnection.deleteRecord().then(function() {
                self.selectFirstObject();
            });
            
        },
        update: function() {
            theConnection = this.get("selectedConnection");
            theConnection.save();
        },
        eject: function(theEntry) {
            if(arguments.length == 1) {
                theConnection = theEntry;
            } else {
                theConnection = this.get("selectedConnection");    
            }
            theConnection.eject();
        },
        cancel: function() {
            theConnection = this.get("selectedConnection");
            expandrive.ejectDrive(theConnection.id);
            theConnection.set('status', null);
        },
        reveal: function(theEntry) {
          if(arguments.length == 1) {
                theConnection = theEntry;
            } else {
                theConnection = this.get("selectedConnection");    
            }
            mountpoint = theConnection.get("mountpoint");
            if(mountpoint != undefined && mountpoint != ""){
                expandrive.revealDrive(mountpoint)
            }
        },
        startOauth: function() {
            window.oauthemail = null;
            window.oauthrefresh = null;
            theConnection = this.get("selectedConnection");
            if(theConnection.get("type") == "gdrive")
                oauth.startGDriveAuth();
            if(theConnection.get("type") == "box")
                oauth.startBoxAuth();
            if(theConnection.get("type") == "dropbox")
                oauth.startDropboxAuth();

            self = this;
            setTimeout(function() {
                self.oauthFinish();
            }, 500);
            

        },
        feedback: function() {
            settings.sendFeedback();
        },

        license: function() {
            settings.sendToStore();
        },

    },

    oauthFinish: function() {
        self = this;
        theConnection = this.get("selectedConnection");

        if(window.oauthemail != null && window.oauthemail != "canceled") {
            theConnection.set("username", window.oauthemail);
            theConnection.set("password", window.oauthrefresh);
            theConnection.save();
            window.oauthemail = null;
            window.oauthrefresh = null;
        } else if(window.oauthemail != "canceled") {
            setTimeout(function() {
                self.oauthFinish();
            }, 500);
        }
    },

    sidebarActiveButton: null,

    license: App.license,
    
    statusMessage: function() {

        if (this.tipMessage)
            return this.tipMessage;

        if (this.paused)
            return "Syncing paused"

        if (!this.online)
            return "Connecting..."

        if (this.cliMessage)
            return this.cliMessage;

        return "";
    }.property('tipMessage', 'cliMessage', 'paused', 'online'),


    reveal: function() {

        //seconds = new Date().getTime() / 1000;

        if (typeof(file) != "undefined")
            file.openPath("~/Strongsync");
        else {
            enterLicense();
        }

    },

    revealItem: function(data) {
        file.revealPath("~/Strongsync" + data);
    },

    preferences: function() {

        if (typeof(preferencesMenu) == "undefined") {
            configureConnection();
        } else {
            preferencesMenu.show();
        }
    },

    ftpEncryptionOptions: [{
        name: "FTP",
        value: "ENC_NONE"
    }, {
        name: "FTPS with TLS/SSL",
        value: "ENC_REQ"
    }, {
        name: "FTPS with TLS/SSL (login only)",
        value: "ENC_WANT"
    }],

    driveLetters: function() {
        var str = "ABDEFGHIJKLMNOPQRSTUVWXYZ";
        var r = [];

        for (var i = (str.length - 1); i >= 0; i--) {
            r.push({
                name: str.charAt(i) + ":",
                value: str.charAt(i) + ":"
            });
        }

        return r;
    }.property(),

    authenticationTypes: function() {
        items = [{
            name: "Password",
            value: "password"
        }, {
            name: "SSH Key",
            value: "publickey"
        }];

        if(this.get("controllers.application.isPlatformWindows")) {
            items.push({
            name: "Pageant",
            value: "pageant"
            });
        }

        return items;
    }.property(),

    showDriveButtons: function() {
        s = this.get("selectedConnection");

        if(s == undefined) {
            return;
        }

        if(s.get("requireValidation") == true) {
            return false;
        }

        if(s && s.get("isOauthConnection")) {
            if(s.get("isOauthAuthorized")) {
                return true;
            }
            return false;
        } 

        return true;
    }.property("selectedConnection.type", "selectedConnection.isOauthAuthorized", "selectedConnection.requireValidation")
});





App.IndexRoute = Ember.Route.extend({
    setupController: function(controller, model) {
        controller.set('model', model);
        if(this.controllerFor('index').get("selectedConnection") == null)
            this.controllerFor('index').selectFirstObject();
        this.controllerFor('index').set("sidebarActiveButton", "drives-active");
    },
    renderTemplate: function() {
        this.render('sidebar', { // the template to render
            outlet: 'sidebar', // the name of the outlet in the route's template
            controller: 'index' // the controller to use for the template
        });
        this.render('connections', {
            outlet: 'content',
            controller: 'index'
        });
        this.render('details', {
            outlet: 'details',
            controller: 'index'
        });
    },

    beforeModel: function() {
        l = App.license;
        if (l.get("newUser")) {
            this.transitionTo("welcome");
        }
    },

    afterModel: function(m) {
        if(!Ember.isArray(m) || m.get("length") == 0) {
            this.transitionTo("new");
        }
    },

    model: function() {
        return App.Connection.fetch();
    },
});